<?php
/**
 * Plugin Name:       Addify Group Buying
 * Requires Plugins: woocommerce
 * Plugin URI:        https://woocommerce.com/products/addify-group-buying
 * Description:       Allow customers to create group to buy product according to register user role.
 * Version:           1.0.0
 * Author:            Addify
 * Developed By:      Addify
 * Author URI:        https://woocommerce.com/vendor/addify/
 * Support:           https://woocommerce.com/vendor/addify/
 * Domain Path:       /languages
 * Text Domain:       addify-group-buying
 * License: GNU General Public License v3.0
 * License URI: http://www.gnu.org/licenses/gpl-3.0.html
 * WC requires at least: 3.0.9
 * WC tested up to: 8.*.*
 * Woo
 *
 * @package addify-group-buying
 */

if (!defined('ABSPATH')) {
	exit();
}

if (!class_exists('Addify_Group_Buying')) {

	class Addify_Group_Buying {
	

		public function __construct() {
			$this->addify_gpby_global_constents_vars();
			add_action('plugin_loaded', array( $this, 'af_pc_plugin_loaded' ));
			add_action('before_woocommerce_init', array( $this, 'adf_gpby_wsp_HOPS_Compatibility' ));
			register_activation_hook(__FILE__, array( $this, 'adf_gpby_setting_save' ));

			include_once AF_GPBY_DIR . 'includes/main.php';
		}
		
		public function addify_gpby_global_constents_vars() {
			if (!defined('AF_GPBY_URL')) {
				define('AF_GPBY_URL', plugin_dir_url(__FILE__));
			}
			if (!defined('AF_GPBY_DIR')) {
				define('AF_GPBY_DIR', plugin_dir_path(__FILE__));
			}
		}

		public function adf_gpby_wsp_HOPS_Compatibility() {

			if ( class_exists( \Automattic\WooCommerce\Utilities\FeaturesUtil::class ) ) {
				\Automattic\WooCommerce\Utilities\FeaturesUtil::declare_compatibility( 'custom_order_tables', __FILE__, true );
			}
		}

		public function af_pc_plugin_loaded() {
			if ( function_exists('load_plugin_textdomain') ) {
				load_plugin_textdomain( 'addify-group-buying', false, AF_GPBY_DIR . '/languages' );

			}
		}

		public function adf_gpby_setting_save() {
			 
			$default_options = array(
				'adf_gpby_counter_option' => 'counter',
				'gp_by_btn_lbl' => 'Group buy',
				'buy_btn_txt_clr' => '#ffffff',
				'buy_btn_bg_clr' => '#333333',
				'crt_gp_btn_lbl' => 'Create group',
				'crt_gp_btn_txt_clr' => '#ffffff',
				'crt_gp_btn_bg_clr' => '#333333',
				'adf_gpby_order_stat' => 'wc-on-hold',  
				'adf_gpby_term_condition' => 'Group buy enabling you to purchase products in groups to earn massive discounts. Create or join a group and complete the required members count to earn discounts on group purchases.',
				'adf_gpby_term_condition_desc' => 'Group buy enabling you to purchase products in groups to earn massive discounts. Create or join a group and complete the required members count to earn discounts on group purchases.',
			);
		
			if (get_option('adf_gpby_general_settings') === false) {
				add_option('adf_gpby_general_settings', $default_options);
			}
		}
	}
	new Addify_Group_Buying();
}
