<?php

if (!defined('ABSPATH')) {
	exit();
}

	add_action('wp_ajax_afpv_search_product', 'adf_gpby_live_search');
	add_action('wp_ajax_bmsm_category_search', 'bmsm_category_search');
	add_action('wp_ajax_bmsm_user_role_search', 'bmsm_user_role_search');
	add_action('wp_ajax_save_group_data', 'save_group_data');
	add_action('wp_ajax_nopriv_save_group_data', 'save_group_data');
	add_action('wp_ajax_group_buy_add_to_cart', 'group_buy_add_to_cart');
	add_action('wp_ajax_nopriv_group_buy_add_to_cart', 'group_buy_add_to_cart');
	add_action('wp_ajax_afpv_search_user_email', 'adf_search_user_email');

	// Select Product on admin side Callback
function adf_gpby_live_search() {
	if (empty($_POST['nonce']) || !wp_verify_nonce(sanitize_text_field($_POST['nonce']), 'addify_gpby_meta_box')) {
		die('Failed ajax security check!');
	}

	$pro = isset($_POST['q']) && '' !== sanitize_text_field(wp_unslash($_POST['q'])) ? sanitize_text_field(wp_unslash($_POST['q'])) : '';
	$search_type = isset($_POST['search_type']) && '' !== sanitize_text_field(wp_unslash($_POST['search_type'])) ? sanitize_text_field(wp_unslash($_POST['search_type'])) : '';

	$data_array = array();
	$aurguments = array();

	if ('products' == $search_type) {

		$args = array(
			'post_type' => 'product',
			'post_status' => 'publish',
			'posts_per_page' => 100,
			's' => $pro,
			'return' => 'ids',
			'orderby' => 'title',
			'order' => 'ASC',
		);
			
		$pros = get_posts($args);

		if (!empty($pros)) {
			foreach ($pros as $proo) {
				$product = wc_get_product($proo->ID);
				$title = ( mb_strlen($proo->post_title) > 50 ) ? mb_substr($proo->post_title, 0, 49) . '...' : $proo->post_title;
				$data_array[] = array( $proo->ID, $title ); 
					
			}
		}
	}
	if ('categories' == $search_type) {

		$orderby = 'name';
		$order = 'asc';
		$hide_empty = false;
		$aurguments = array(
			'taxonomy' => 'product_cat',
			'orderby' => $orderby,
			'order' => $order,
			'hide_empty' => $hide_empty,
			'name__like' => $pro,
		);

		$product_categories = get_terms($aurguments);

		if (!empty($product_categories)) {
			foreach ($product_categories as $proo) {
	
				$pro_front_post = ( mb_strlen($proo->name) > 50 ) ? mb_substr($proo->name, 0, 49) . '...' : $proo->name;
				$data_array[] = array( $proo->term_id, $pro_front_post ); // array( Post ID, Post Title ).
			}
		}

	}

	if ('userroles' == $search_type) {

		global $wp_roles;
		$all_roles = $wp_roles->roles;

		foreach ($all_roles as $role_key => $role) {
			if (stripos($role['name'], $pro) !== false) {
				$role_name = ( mb_strlen($role['name']) > 50 ) ? mb_substr($role['name'], 0, 49) . '...' : $role['name'];
				$data_array[] = array( $role_key, $role_name ); // array(Role Key, Role Name)
			}
		}

	}

	if ('payment_method' == $search_type) {
			
		$payment_gateways = WC()->payment_gateways->get_available_payment_gateways();
	
		foreach ($payment_gateways as $gateway_id => $gateway) {
			if (stripos($gateway->get_title(), $pro) !== false) {
				$gateway_name = ( mb_strlen($gateway->get_title()) > 50 ) ? mb_substr($gateway->get_title(), 0, 49) . '...' : $gateway->get_title();
				$data_array[] = array( $gateway_id, $gateway_name ); 
			}
		}

	}

	echo wp_json_encode($data_array);

	wp_die();
}

function bmsm_category_search() {
			
	if (empty($_POST['nonce']) || !wp_verify_nonce(sanitize_text_field($_POST['nonce']), 'addify_bmsm_meta_box')) {
		die('Failed ajax security check!');
	}
	
	if (isset($_POST['q']) && '' !== $_POST['q']) {
		$pro = sanitize_text_field(wp_unslash($_POST['q']));
	} else {
		$pro = '';
	}
	$data_array = array();
	$orderby = 'name';
	$order = 'asc';
	$hide_empty = false;
	$cat_args = array(
		'orderby' => $orderby,
		'order' => $order,
		'hide_empty' => $hide_empty,
		'name__like' => $pro,
	);
	
	$product_categories = get_terms($cat_args);
	
	if (!empty($product_categories)) {
		foreach ($product_categories as $proo) {
	
			$pro_front_post = ( mb_strlen($proo->name) > 50 ) ? mb_substr($proo->name, 0, 49) . '...' : $proo->name;
			$data_array[] = array( $proo->term_id, $pro_front_post ); // array( Post ID, Post Title ).
		}
	}
	
	echo wp_json_encode($data_array);
	wp_die();
}

function bmsm_user_role_search() {
			
	if (empty($_POST['nonce']) || !wp_verify_nonce(sanitize_text_field($_POST['nonce']), 'addify_bmsm_meta_box')) {
		die('Failed ajax security check!');
	}
			
	if (isset($_POST['q']) && '' != $_POST['q']) {
		$pro = sanitize_text_field($_POST['q']);
	} else {
		$pro = '';
	}

	$data_array = array();
	global $wp_roles;
	$all_roles = $wp_roles->roles;

	foreach ($all_roles as $role_key => $role) {
		if (stripos($role['name'], $pro) !== false) {
			$role_name = ( mb_strlen($role['name']) > 50 ) ? mb_substr($role['name'], 0, 49) . '...' : $role['name'];
			$data_array[] = array( $role_key, $role_name ); // array(Role Key, Role Name)
		}
	}
			
	$data_array[] = array( 'guest', 'Guest' );  
	wp_send_json($data_array);
	wp_die();
}

		//search user eamil front side
function adf_search_user_email() {
	if (empty($_POST['nonce']) || !wp_verify_nonce(sanitize_text_field($_POST['nonce']), 'addify_bmsm_meta_box')) {
		die('Failed ajax security check!');
	}
			
	$data_array = array();
	$users = get_users();

	foreach ($users as $user_key => $user) {
		$data_array[] = array( $user->user_email, $user->user_email );
	}
		 
	wp_send_json($data_array);
	wp_die();
}

		//save the data of creation group

function save_group_data() {
	// Check nonce for security
	if (!isset($_POST['nonce']) || !wp_verify_nonce(sanitize_text_field($_POST['nonce']), 'adf_gpby_group_form')) {
		wp_send_json_error('Invalid nonce');
		return;
	}

	if (!isset($_POST['form'])) {
		return;
	}

	$user_email = array();
	$user_id = get_current_user_id();
	$user_obj = wp_get_current_user();
			
	// wp_parse_str($_POST['form'], $form_data);
	$form_string = sanitize_text_field($_POST['form']);
	
	// Parse the sanitized string into an array
	parse_str($form_string, $form_data);
	
	$product_name = sanitize_text_field($form_data['adf_gpby_product_name']);
	$group_name = sanitize_text_field($form_data['adf_db_group_name']);
	$group_type = sanitize_text_field($form_data['adf_db_group_type']);
	$post_id = sanitize_text_field($form_data['adf_curt_prod_id']);
	$days = sanitize_text_field($form_data['adf_gpby_actic_days']);
	$discount = sanitize_text_field($form_data['adf_gpby_disc_price']);
	$discountType = sanitize_text_field($form_data['adf_discount_type']);
	$Pricetype = sanitize_text_field($form_data['adf_gpby_price_type']);
	$noOfPublicGp = sanitize_text_field($form_data['adf_gpby_no_public_group']);
	$noOfPrivateGp = sanitize_text_field($form_data['adf_gpby_no_private_group']);
	$allowSingleCustomer = sanitize_text_field($form_data['adf_gpby_sin_cus_enb']);
	$currentPostId = sanitize_text_field($form_data['adf_gpby_current_post_id']);
	$adfAllowMemeberGroup = sanitize_text_field($form_data['adf_gpby_no_allow_memeber_group']);
	$adfAppliedUserRole = sanitize_text_field($form_data['adf_gpby_applied_user_roles']);

	if (!empty($adfAppliedUserRole)) {
		$adfAppliedUserRole = explode('_', $adfAppliedUserRole);
	}
	
	$user_email = isset( $_POST['emails'] ) && '' !== $_POST['emails'] ? sanitize_meta('', $_POST['emails'], '') : array();

	if (is_array($user_email)) :
		array_push($user_email, $user_obj->user_email);
		$user_email = array_filter($user_email, function ( $value ) {
			return null !== $value;
		});
	endif;
	
	$endDate = calculateEndDate(current_datetime()->format('Y-m-d'), $days);
	
	$args = array(
		'post_type' => 'addify_gpinfo',
		'posts_per_page' => -1,
		'meta_query' => array(
			'relation' => 'AND',
			array(
				'key' => 'adf_pgif_product_id',
				'value' => $post_id,
				'compare' => '=',
			),
			array(
				'key' => 'adf_pgif_user_id',
				'value' => $user_id,
				'compare' => '=',
			),

			array(
				'key' => 'adf_gpby_group_info_status',
				'value' => 'processing',
				'compare' => '=',
			),
		),
	);
	$query = new WP_Query($args);
		 
	if ($query->have_posts()) :
		$return = array(
			'message'  => 'you only create one group each product',
		);
		wp_send_json($return);
	endif;
			
	$post_form_data = array(
		'group_id' => $user_id . '_group_' . $post_id,
		'group_name'  => $group_name,
		'group_type' => $group_type,
		'user_id' => $user_id,
		'user_name' => $user_obj->user_firstname,
		'endDate' => $endDate,
		'discount' => $discount,
		'product_name' => $product_name,
		'product_id' => $post_id,
		'user_email' => $user_email,
		'discountType' => $discountType,
		'Pricetype' => $Pricetype,
		'noOfPublicGp' => $noOfPublicGp,
		'noOfPrivateGp' => $noOfPrivateGp,
		'allowSingleCustomer' => $allowSingleCustomer,
		'adfAllowMemeberGroup' => $adfAllowMemeberGroup,
		'adfAppliedUserRole' => $adfAppliedUserRole,
	);

	saveGroupData($currentPostId, $post_form_data);
	wp_send_json_success('Data saved successfully');
}

function calculateEndDate( $startDate, $duration ) {
	return gmdate('Y-m-d', strtotime($startDate . ' + ' . $duration . ' days'));
}
		

function group_buy_add_to_cart() {

	if ( ! isset($_POST['form']) ) {
		return;
	}
			
	if (!isset($_POST['nonce']) || !wp_verify_nonce(sanitize_text_field($_POST['nonce']), 'adf_gpby_group_form')) {
		wp_send_json_error('Invalid nonce');
		return;
	}

	parse_str(sanitize_text_field($_POST['form']), $form);
		
	$product_id = intval($form['adf_product_Id']);
	$group_id = $form['adf_gpby_group_id'];
	$sing_cust_enable = $form['adf_single_customer_en'];
	$total_group_size = intval($form['adf_tol_num_member']);
	$total_purchase_customer = intval($form['adf_purcahse_num_member']);
	if (isset($form_data) && isset($form_data['adf_gpby_grototal_up_size'])) {
		$groupSize = $form_data['adf_gpby_grototal_up_size'];
	} else {
		$groupSize = ''; 
	}

	if ($product_id > 0) {      
		$user_id = get_current_user_id();
		$args = array(
			'post_type' => 'addify_gpinfo',
			'posts_per_page' => -1,
			'post_status' => 'publish',
			'meta_query' => array(
				array(
					'key' => 'adf_pgif_product_id',
					'value' => $product_id,
					'compare' => '=',
				),
				array(
					'key' => 'adf_gpby_group_info_status',
					'value' => 'processing',
					'compare' => '=',
				),
			),
		);
		
		$query = new WP_Query($args);
	
		if ($query->have_posts()) :   
			while ($query->have_posts()) :
				$query->the_post();
				$post_id = get_the_ID();
																		
				$sing_cust_enable = get_post_meta($post_id, 'adf_gpif_allow_sing_customer', true);
				$buyGroupCustmerDataDb = get_post_meta($post_id, 'adf_pgif_join_group_member_info', true);
				if (is_array($buyGroupCustmerDataDb)) :
					foreach ($buyGroupCustmerDataDb as $getData) :
						if (is_array($getData)) :
							$strippedData = array_map('strip_tags', $getData);
							if (in_array($user_id, $strippedData) && in_array($group_id, $strippedData) && 'true' == $sing_cust_enable) :
								$return = array(
									'message'  => 'You have ordered the product buy this group already',
								);
								wp_send_json($return);
							endif;
						endif;
					endforeach;
				endif;
			endwhile; 
		endif;
				
		foreach (WC()->cart->get_cart() as $cart_item_key => $cart_item) :
			if ($cart_item['product_id'] === $product_id && 'true' == $sing_cust_enable) :
				$return = array(
					'message'  => 'You can only add one product from one group',
				);
				wp_send_json($return);
			endif;
		endforeach;

		foreach (WC()->cart->get_cart() as $cart_item_key => $cart_item) :
			if (!isset($cart_item['groupId'])) :
				$return = array(
					'message'  => "First empty your cart, you can't add simple and group products together.",
				);
				wp_send_json($return);
			elseif ($cart_item['buyGroupId'] == $group_id) :
				if (( $total_purchase_customer+$cart_item['quantity'] ) >= $total_group_size) :
					$return = array(
						'message'  => 'Increase product quantity to group size limit',
					);
					wp_send_json($return);
;
				endif;
			endif;
		endforeach;
				
			   
		$added = WC()->cart->add_to_cart($product_id, 1, 0, array(), array(
			'groupId'=>$product_id,
			'buyGroupId' => $group_id,
		));
	   ;
		if ($added) {
			wp_send_json_success();
		} else {
			wp_send_json_error();
		}
	} else {
		wp_send_json_error();
	}
}

function saveGroupData( $parent_post_id, $post_form_data ) {
	$user_obj = wp_get_current_user();
	$new_post = array(
		'post_type' => 'addify_gpinfo', // Custom Post Type Slug
		'post_status' => 'publish',
		'post_title' => $post_form_data['group_name'],
		'post_parent'  => $parent_post_id,
	);

	$post_id = wp_insert_post($new_post);
	$post = get_post($post_id);

	if ($post_id) {
		if ('percent' === $post_form_data['discountType']) :
			$Sign = '%';
		elseif ('fixed' === $post_form_data['discountType']) :  
			$Sign = get_woocommerce_currency_symbol(); 
		endif;

		update_post_meta($post_id, 'adf_pgif_group_id', $post_form_data['group_id']);
		update_post_meta($post_id, 'adf_pgif_group_name', $post_form_data['group_name']);
		update_post_meta($post_id, 'adf_pgif_group_type', $post_form_data['group_type']);
		update_post_meta($post_id, 'adf_pgif_group_price', $post_form_data['discount'] . $Sign);
		update_post_meta($post_id, 'adf_pgif_user_id', $post_form_data['user_id']);
		update_post_meta($post_id, 'adf_pgif_group_auth', $post_form_data['user_name']);
		update_post_meta($post_id, 'adf_pgif_group_created', current_datetime()->format('Y-m-d'));
		update_post_meta($post_id, 'adf_pgif_group_exprire', $post_form_data['endDate']);
		update_post_meta($post_id, 'adf_pgif_product_id', $post_form_data['product_id']);
		update_post_meta($post_id, 'adf_pgif_product_name', $post_form_data['product_name']);
		update_post_meta($post_id, 'adf_gpby_group_allow_users', $post_form_data['user_email']);
		update_post_meta($post_id, 'adf_gpby_group_info_status', 'processing');
		update_post_meta($post_id, 'adf_gpby_group_info_prc_type', $post_form_data['Pricetype']);
		update_post_meta($post_id, 'adf_pgif_discount_type', $post_form_data['discountType']);
		update_post_meta($post_id, 'adf_pgif_no_public_grp', $post_form_data['noOfPublicGp']);
		update_post_meta($post_id, 'adf_pgif_no_private_grp', $post_form_data['noOfPrivateGp']);
		update_post_meta($post_id, 'adf_order_showing', 'false');
		update_post_meta($post_id, 'adf_created_group_email', $user_obj->user_email);
		update_post_meta($post_id, 'adf_gpif_allow_sing_customer', $post_form_data['allowSingleCustomer']);
		update_post_meta($post_id, 'adf_gpif_group_member', $post_form_data['adfAllowMemeberGroup']);
		update_post_meta($post_id, 'adf_gpif_applied_user_roles', $post_form_data['adfAppliedUserRole']);
		update_post_meta($post_id, 'adf_created_member_msg', 'First, buy the product from this group, and then it will be shown to other customers.');
			   
	}
}

function getProductParmlink( $id ) {
	$link = get_permalink( $id );
	return $link;
}
