<?php

if (!defined('ABSPATH')) {
	exit();
}

if (!class_exists('Addify_Group_Buying_Main')) :
	class Addify_Group_Buying_Main {

		public function __construct() {
			add_action('init', array( $this, 'check_woocommerce_is_defined_or_not' ));
			add_action('admin_head', array( $this, 'hide_add_new_button' ));
			add_filter('manage_addify_gpinfo_posts_columns', array( $this, 'add_custom_columns' ));
			add_action('manage_addify_gpinfo_posts_custom_column', array( $this, 'custom_column_content' ), 10, 2);
			add_filter('woocommerce_email_classes', array( $this, 'adf_gpby_email_register' ), 90, 1);
		}

		public function check_woocommerce_is_defined_or_not() { 
			
			if (defined('WC_PLUGIN_FILE')) {

				$this->include_files();
				$this->register_post_types();
			}
		}

		public function custom_column_content( $column_name, $post_id ) {
			switch ($column_name) {
				case 'column_status':
					echo '<div class="adf-gbby-status_column">' . esc_attr(ucfirst(get_post_meta($post_id, 'adf_gpby_group_info_status', true))) . '</div>';
					break;
				case 'column_group_size':
					echo esc_attr(get_post_meta($post_id, 'adf_gpif_group_member', true));
					break;
				case 'column_group_name':
					echo esc_attr(get_post_meta($post_id, 'adf_pgif_group_name', true));
					break;
			}
		}
		public function include_files() {
			include_once AF_GPBY_DIR . 'includes/admin/addify-meta-box-gpby.php';
			include_once AF_GPBY_DIR . 'includes/admin/product-custom-tab.php';
			include_once AF_GPBY_DIR . 'includes/ajax-function.php';
			include_once AF_GPBY_DIR . 'includes/admin/adf-gpby-setting.php';
			include_once AF_GPBY_DIR . 'includes/front/adf_gpby_front.php';
			include_once AF_GPBY_DIR . 'includes/front/adf_cart_validation.php';
			include_once AF_GPBY_DIR . 'includes/front/adf_gpby_product_detail.php';
			include_once AF_GPBY_DIR . 'includes/front/adf-gpby-login.php';
		}

		public function add_custom_columns( $columns ) {
			return array(
				'cb' => '<input type="checkbox" />',
				'title' => __('Title'),
				'column_group_name' =>  __('Group Name', 'addify-group-buying'),
				'column_group_size' => __('Group Size', 'addify-group-buying'),
				'column_status' =>  __('Status', 'addify-group-buying'),
				'date' =>__( 'Date'),
			);
		}

		public function hide_add_new_button() {
			global $post_type;
			
			if ('addify_gpinfo' === $post_type) {
				?>
				<script type="text/javascript">
					jQuery(document).ready(function ($) {
					   $('.page-title-action').hide();
					});
				</script>    
				<?php
			}
		}

		public function register_post_types() {
			
			$labels = array(
				'name' => __('Group Buying', 'addify-group-buying'),
				'singular_name' => __('Group Buying', 'addify-group-buying'),
				'add_new' => __('Add New Rule', 'addify-group-buying'),
				'add_new_item' => __('Add Rule', 'addify-group-buying'),
				'edit_item' => __('Edit Rule', 'addify-group-buying'),
				'new_item' => __('New Rule', 'addify-group-buying'),
				'view_item' => __('View Rule', 'addify-group-buying'),
				'search_items' => __('Search Rule', 'addify-group-buying'),
				'exclude_from_search' => true,
				'not_found' => __('No rule found', 'addify-group-buying'),
				'not_found_in_trash' => __('No rule found in trash', 'addify-group-buying'),
				'parent_item_colon' => '',
				'all_items' => __('Group Buying', 'addify-group-buying'),
				'menu_name' => __('Group Buying', 'addify-group-buying'),
			);
	
			$args = array(
				'labels' => $labels,
				'public' => false,
				'publicly_queryable' => false,
				'show_ui' => true,
				'show_in_menu' => 'woocommerce',
				'query_var' => true,
				'capability_type' => 'post',
				'has_archive' => true,
				'hierarchical' => true,
				'menu_position' => 50,
				'rewrite' => array(
					'slug' => 'addify_gpby',
					'with_front' => false,
				),
				'supports' => array( 'title', 'page-attributes' ),
			);
			register_post_type('addify_gpby', $args);

				$labels = array(
					'name' => __('Group Info', 'addify-group-buying'),
					'singular_name' => __('Group Info', 'addify-group-buying'),
					'add_new' => __('Add new', 'addify-group-buying'),
					'add_new_item' => __('Add new', 'addify-group-buying'),
					'edit_item' => __('Edit Rule', 'addify-group-buying'),
					'new_item' => __('New Rule', 'addify-group-buying'),
					'view_item' => __('View Rule', 'addify-group-buying'),
					'search_items' => __('Search Rule', 'addify-group-buying'),
					'exclude_from_search' => true,
					'not_found' => __('No rule found', 'addify-group-buying'),
					'not_found_in_trash' => __('No rule found in trash', 'addify-group-buying'),
					'parent_item_colon' => '',
					'all_items' => __('Group Buying', 'addify-group-buying'),
					'menu_name' => __('Group Buying', 'addify-group-buying'),
				);
		
				$args = array(
					'labels' => $labels,
					'public' => false,
					'publicly_queryable' => false,
					'show_ui' => true,
					'show_in_menu' => 'woocommerce',
					'query_var' => true,
					'capability_type' => 'post',
					'has_archive' => true,
					'hierarchical' => false,
					'menu_position' => 80,
					'rewrite' => array(
						'slug' => 'addify_gpinfo',
						'with_front' => false,
					),
					'supports' => array( 'title' ),
				);
			register_post_type('addify_gpinfo', $args);
		}

		public function adf_gpby_email_register( $emails ) {

		
			include_once AF_GPBY_DIR . 'includes/email/adf_gpby_join_email_register.php';
			$emails['Adf_Gpby_Join_Email_Register'] = new Adf_Gpby_Join_Email_Register();

			include_once AF_GPBY_DIR . 'includes/email/adf_gpby_qualified_group_email.php';
			$emails['Adf_Gpby_Qualified_Group_Email'] = new Adf_Gpby_Qualified_Group_Email();

			include_once AF_GPBY_DIR . 'includes/email/adf_gpby_disqualified_group_email.php';
			$emails['Adf_Gpby_Disqualified_Group_Email'] = new Adf_Gpby_Disqualified_Group_Email();

			include_once AF_GPBY_DIR . 'includes/email/adf_gpby_private_group_email.php';
			$emails['Adf_Gpby_Private_Group_Email'] = new Adf_Gpby_Private_Group_Email();

			return $emails;
		}
	}
	new Addify_Group_Buying_Main();
endif;